/* 
IR Emitter
by Natasha Owczarek at Tomorrow Lab, 2012
emit IR pulses of morse code
*/


const int pulsePin = 10;  // connect to IR LED to send out IR pulses of light

int freq = 255;          // frequency of pwm signal (0-255 goes up to ~490 hz)
int space = 300;        //space after each character and extra one for between words
int dotTime = 100;          //used forlength of dot and space between dots/dashes withIN letter
int dashTime = 250;        //used for length of dash
boolean debug = 0;        // set to 1 for debugging statements on serial

void setup() {
  Serial.begin(9600);
  //initialize communication betweeen IR pair (can be used to create exclusive link)
  analogWrite(pulsePin, freq);
  delay(500);
  digitalWrite(pulsePin, freq);
  delay(500);
}

void loop() {
  //send pulses out
  
  //SOS
  /*char_S();
  char_O();
  char_S();
 */
  char_0();
  char_1(); char_2(); char_3(); char_4(); char_5(); char_6();
  char_7(); char_8(); char_9(); 
  char_A(); char_B(); char_C(); char_D(); char_E(); char_F(); 
  char_G(); char_H(); char_I(); char_J(); char_K(); char_L(); char_M(); char_N(); char_O(); char_P(); 
  char_Q(); char_R(); char_S(); char_T(); char_U(); char_V(); char_W(); char_X(); char_Y(); char_Z(); 
  delay(space);  
  
}

void char_S() {
    for (int i=0; i<3; i++) {
    //analogWrite(pulsePin, freq);    //using pwm
    ////digitalWrite(pulsePin, HIGH);     //using simple 'on'
    //delay(dotTime);
    //digitalWrite(pulsePin, LOW);
    //delay(dotTime); 
    dot();
    }
    if(debug){Serial.print("S");}
  delay(space);
}
void char_O() {
  for (int j=0; j<3; j++) {
    //analogWrite(pulsePin, freq);
    //delay(dashTime);
    //digitalWrite(pulsePin, LOW);
    //delay(dotTime);
    dash();
  }
  if(debug){Serial.print("O");}
  delay(space);
}  
//letters starting with a dot
void char_A() {
  dot();
  dash();
  delay(space);
}
void char_E() {
  dot();
  delay(space);
}
void char_I() {
  dot();
  dot();
  delay(space);
}
void char_H() {
  for (int j=0; j<4; j++) {
    dot();
  }
  delay(space);
}
void char_J() {
  dot();
  for (int j=0; j<3; j++) {
    dash();
  }
  delay(space);
}
void char_F() {
  for (int j=0; j<2; j++) {
    dot();
  }
  dash();
  dot();
  delay(space);
}
void char_L() {
  dot();
  dash();
  for (int j=0; j<2; j++) {
    dot();
  }
  delay(space);
}
void char_P() {
  dot();
  for (int j=0; j<2; j++) {
    dash();
  }
  dot();
  delay(space);
}
void char_R() {
  dot();
  dash();
  dot();
  delay(space);
}
void char_U() {
  for (int j=0; j<2; j++) {
    dot();
  }
  dash();
  delay(space);
}
void char_V() {
  for (int j=0; j<3; j++) {
    dot();
  }
  dash();
  delay(space);
}
void char_W() {
  dot();
  for (int j=0; j<2; j++) {
    dash();
  }
  delay(space);
}
//letters starting with a dash
void char_B() {
  dash();
  for (int j=0; j<3; j++) {
    dot();
  }
  delay(space);
}
void char_C() {
  dash();
  dot();
  dash();
  dot();
  delay(space);
}
void char_D() {
  dash();
  for (int j=0; j<2; j++) {
    dot();
  }
  delay(space);
}
void char_G() {
  for (int j=0; j<2; j++) {
    dash();
  }
  dot();
  delay(space);
}
void char_K() {
  dash();
  dot();
  dash();
  delay(space);
}
void char_M() {
  dash();
  dash();
  delay(space);
}
void char_N() {
  dash();
  dot();
  delay(space);
}
void char_Q() {
  for (int j=0; j<2; j++) {
    dash();
  }
  dot();
  dash();
  delay(space);
}
void char_T() {
  dash();
  delay(space);
}
void char_X() {
  dash();
  for (int j=0; j<2; j++) {
    dot();
  }
  dash();
  delay(space);
}
void char_Y() {
  dash();
  dot();
  for (int j=0; j<2; j++) {
    dash();
  }
  delay(space);
}
void char_Z() {
  dash();
  dash();
  for (int j=0; j<2; j++) {
    dot();
  }
  delay(space);
}
//numbers
void char_1() {
  dot();
  for (int j=0; j<4; j++) {
    dash();
  }
  delay(space);
}
void char_2() {
  dot();
  dot();
  for (int j=0; j<3; j++) {
    dash();
  }
  delay(space);
}
void char_3() {
  for (int j=0; j<3; j++) {
    dot();
  }
  dash();
  dash();
  delay(space);
}
void char_4() {
  for (int j=0; j<4; j++) {
    dot();
  }
  dash();
  delay(space);
}
void char_5() {
  for (int j=0; j<5; j++) {
    dot();
  }
  delay(space);
}
void char_6() {
  dash();
  for (int j=0; j<4; j++) {
    dot();
  }
  delay(space);
}
void char_7() {
  dash();
  dash();
  for (int j=0; j<3; j++) {
    dot();
  }
  delay(space);
}
void char_8() {
  for (int j=0; j<3; j++) {
    dash();
  }
  dot();
  dot();
  delay(space);
}
void char_9() {
  for (int j=0; j<4; j++) {
    dash();
  }
  dot();
  delay(space);
}
void char_0() {
  for (int j=0; j<5; j++) {
    dash();
  }
  delay(space);
}
// dots and dashes
void dot() {
  analogWrite(pulsePin, freq);
  delay(dotTime);
  analogWrite(pulsePin, LOW);
  delay(dotTime);
}
void dash() {
  analogWrite(pulsePin, freq);
  delay(dashTime);
  digitalWrite(pulsePin, LOW);
  delay(dotTime);
}

